#define DEBUG false

// defines pins numbers
const int stepPin = 3; 
const int dirPin = 4; 

const int onPushbtn = 8;
boolean onPushbtn_PRESSED = LOW;
const int offPushbtn = 9;
boolean offPushbtn_PRESSED = LOW;

// status programma
#define STAT_DO_NOTHING 0
#define STAT_DRAAI_VOORWAARDS 1
int status;

 long onPushbtnbuttonTimer = 0;
#define onPushbtnminShortPressTime 80
#define onPushbtnlongPressTime 750
boolean onPushbtnbuttonActive = false;
boolean onPushbtnlongPressActive = false;
#define onPushbtnNOPRESS    0
#define onPushbtnSHORTPRESS 1
#define onPushbtnLONGPRESS  2
int onPushbtnPressType = onPushbtnNOPRESS;

long offPushbtnbuttonTimer = 0;
#define offPushbtnminShortPressTime 80
#define offPushbtnlongPressTime 750
boolean offPushbtnbuttonActive = false;
boolean offPushbtnlongPressActive = false;
#define offPushbtnNOPRESS    0
#define offPushbtnSHORTPRESS 1
#define offPushbtnLONGPRESS  2
int offPushbtnPressType = offPushbtnNOPRESS;


void handleonPushbtnPress() {
  onPushbtnPressType = onPushbtnNOPRESS;
      if (digitalRead(onPushbtn) == onPushbtn_PRESSED) {
        if (onPushbtnbuttonActive == false) {
          onPushbtnbuttonActive = true;
          onPushbtnbuttonTimer = millis();
        }
        if ((millis() - onPushbtnbuttonTimer > onPushbtnlongPressTime) && (onPushbtnlongPressActive == false)) {
          onPushbtnlongPressActive = true;
          onPushbtnPressType = onPushbtnLONGPRESS;
        }
      } else {
        if (onPushbtnbuttonActive == true) {
          if (onPushbtnlongPressActive == true) {
            onPushbtnlongPressActive = false;
          } else {
            //avoid fast fluctuations to be identified as a click
            if (millis() - onPushbtnbuttonTimer > onPushbtnminShortPressTime)
              onPushbtnPressType = onPushbtnSHORTPRESS;
          }
          onPushbtnbuttonActive = false;
        }
      }
}

void handleoffPushbtnPress() {
  offPushbtnPressType = offPushbtnNOPRESS;
      if (digitalRead(offPushbtn) == offPushbtn_PRESSED) {
        if (offPushbtnbuttonActive == false) {
          offPushbtnbuttonActive = true;
          offPushbtnbuttonTimer = millis();
        }
        if ((millis() - offPushbtnbuttonTimer > offPushbtnlongPressTime) && (offPushbtnlongPressActive == false)) {
          offPushbtnlongPressActive = true;
          offPushbtnPressType = offPushbtnLONGPRESS;
        }
      } else {
        if (offPushbtnbuttonActive == true) {
          if (offPushbtnlongPressActive == true) {
            offPushbtnlongPressActive = false;
          } else {
            //avoid fast fluctuations to be identified as a click
            if (millis() - offPushbtnbuttonTimer > offPushbtnminShortPressTime)
              offPushbtnPressType = offPushbtnSHORTPRESS;
          }
          offPushbtnbuttonActive = false;
        }
      }
}

void setup() {
  
  // Sets the two pins as Outputs
  pinMode(stepPin,OUTPUT); 
  pinMode(dirPin,OUTPUT);
  // On and off button
  pinMode(onPushbtn, INPUT_PULLUP);
  pinMode(offPushbtn, INPUT_PULLUP);

  status = STAT_DO_NOTHING;
  //status = STAT_DRAAI_VOORWAARDS;
  digitalWrite(dirPin, HIGH);

  if (DEBUG) Serial.begin(57600);
}

void loop() {
  // Check Push BUttons
  
  handleonPushbtnPress();

  if (onPushbtnPressType == onPushbtnSHORTPRESS) {
    //START STATEMENTS SHORT PRESS
    status += 1;
    if (status > 4) {
      status = STAT_DRAAI_VOORWAARDS;
    } else if (status == 0) {
      status = STAT_DO_NOTHING;
    }
    if (status > 0) {
      digitalWrite(dirPin, HIGH); // Enables the motor to move in a particular direction
    } else if (status < 0){
      digitalWrite(dirPin, LOW); // Enables the motor to move in a particular direction
    }
    //END  STATEMENTS SHORT PRESS
  } else if (onPushbtnPressType == onPushbtnLONGPRESS) {
    //START STATEMENTS LONG PRESS
    status -= 1;
    if (status < -4) {
      status = -1*STAT_DRAAI_VOORWAARDS;
    } else if (status == 0) {
      status = STAT_DO_NOTHING;
    }
    if (status > 0) {
      digitalWrite(dirPin, HIGH); // Enables the motor to move in a particular direction
    } else if (status < 0){
      digitalWrite(dirPin, LOW); // Enables the motor to move in a particular direction
    }
    //END  STATEMENTS LONG PRESS
  } else if (!onPushbtnlongPressActive && digitalRead(onPushbtn) == onPushbtn_PRESSED) {
    //START STATEMENTS PRESS
    //END  STATEMENTS PRESS
  }

  handleoffPushbtnPress();

  if (offPushbtnPressType == offPushbtnSHORTPRESS) {
    //START STATEMENTS SHORT PRESS
    status = STAT_DO_NOTHING;
    //END  STATEMENTS SHORT PRESS
  } else if (offPushbtnPressType == offPushbtnLONGPRESS) {
    //START STATEMENTS LONG PRESS
    //END  STATEMENTS LONG PRESS
  } else if (!offPushbtnlongPressActive && digitalRead(offPushbtn) == offPushbtn_PRESSED) {
    //START STATEMENTS PRESS
    //END  STATEMENTS PRESS
  }

  if (DEBUG) {
    Serial.print(offPushbtnPressType);
    Serial.print(", ");
    Serial.print(onPushbtnPressType);
    Serial.print(", ");
    Serial.print(status);
    Serial.println("; ");
    delay(100);
  }
  if (status == STAT_DO_NOTHING) {
    //continue;
  } else {
    // do the step
    int tmpstat = abs(status);
    digitalWrite(stepPin, HIGH); 
    delayMicroseconds(6000-tmpstat*1000-3); 
    digitalWrite(stepPin, LOW); 
    delayMicroseconds(6000-tmpstat*1000-3);
    //delay(5-tmpstat);
  }
  
}
